



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BZOJ3456 城市规划（多项式求逆）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BZOJ3456 城市规划（多项式求逆）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 14:40:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　设f[i]为连通图的数量，g[i]为不连通图的数量，显然有f[i]=2<sup>i*(i-1)/2</sup>-g[i]，g[i]通过枚举1所在连通块大小转移，有g[i]=&Sigma;f[j]*C(i-1,j-1)&middot;2<sup>(i-j)*(i-j-1)/2</sup>，也即f[i]=2<sup>i*(i-1)/2</sup>-(i-1)!&middot;&Sigma;f[j]&middot;2<sup>(i-j)*(i-j-1)/2</sup>/(j-1)!/(i-j)!。显然是一个卷积形式，可以分治NTT。</p>
<p>　　进一步将式子化的更优美一点。设h[i]=2<sup>i*(i-1)/2</sup>，有f[i]=h[i]-(i-1)!&middot;&Sigma;f[j]&middot;h[i-j]/(j-1)!/(i-j)!。阶乘项也可以弄掉，设F[i]=f[i]/(i-1)!，H[i]=h[i]/(i-1)!，G[i]=h[i]/i!，则有F[i]=H[i]-&Sigma;F[j]&middot;G[i-j] (0&lt;j&lt;i)，而G[0]=1，不妨设F[0]=H[0]=0，则H[i]=&Sigma;F[j]&middot;G[i-j] (0&lt;=j&lt;=i)，标准的卷积。设F(x),G(x),H(x)为其各自的生成函数，则H(x)=F(x)&middot;G(x)。H(x)和G(x)我们很容易就能算出来，所以求一发逆就有F(x)了。</p>
<p>　　预定本年度最弱智bug：定义了全局变量inv3预处理3的逆元，在主程序里给其赋值，写了int inv3=&hellip;&hellip;。然后就盯着两份一模一样的代码调了一年。</p>
<p>　　upd：原来这个除了阶乘的东西就叫指数型生成函数？</p>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;<br />
#include&lt;cstdio&gt;<br />
#include&lt;cmath&gt;<br />
#include&lt;cstdlib&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;algorithm&gt;<br />
using namespace std;<br />
#define ll long long<br />
#define N 540000<br />
#define P 1004535809<br />
char getc(){char c=getchar();while ((c&lt;'A'||c&gt;'Z')&amp;&amp;(c&lt;'a'||c&gt;'z')&amp;&amp;(c&lt;''||c&gt;'')) c=getchar();return c;}<br />
int gcd(int n,int m){return m==?n:gcd(m,n%m);}<br />
int read()<br />
{<br />
    int x=,f=;char c=getchar();<br />
    while (c&lt;''||c&gt;'') {if (c=='-') f=-;c=getchar();}<br />
    while (c&gt;=''&amp;&amp;c&lt;='') x=(x&lt;&lt;)+(x&lt;&lt;)+(c^),c=getchar();<br />
    return x*f;<br />
}<br />
int n,f[N],g[N],h[N],fac[N],inv[N],r[N],tmp[N],inv3;<br />
int ksm(int a,int k)<br />
{<br />
    int s=;<br />
    for (;k;k&gt;&gt;=,a=1ll*a*a%P) if (k&amp;) s=1ll*s*a%P;<br />
    return s;<br />
}<br />
void DFT(int *a,int n,int g)<br />
{<br />
    for (int i=;i&lt;n;i++) if (i&lt;r[i]) swap(a[i],a[r[i]]);<br />
    for (int i=;i&lt;=n;i&lt;&lt;=)<br />
    {<br />
        int wn=ksm(g,(P-)/i);<br />
        for (int j=;j&lt;n;j+=i)<br />
        {<br />
            int w=;<br />
            for (int k=j;k&lt;j+(i&gt;&gt;);k++,w=1ll*w*wn%P)<br />
            {<br />
                int x=a[k],y=1ll*w*a[k+(i&gt;&gt;)]%P;<br />
                a[k]=(x+y)%P,a[k+(i&gt;&gt;)]=(x-y+P)%P;<br />
            }<br />
        }<br />
    }<br />
}<br />
void mul(int *a,int *b,int n,int op)<br />
{<br />
    for (int i=;i&lt;n;i++) r[i]=(r[i&gt;&gt;]&gt;&gt;)|(i&amp;)*(n&gt;&gt;);<br />
    DFT(a,n,),DFT(b,n,);<br />
    if (op==) for (int i=;i&lt;n;i++) a[i]=1ll*a[i]*b[i]%P;<br />
    else for (int i=;i&lt;n;i++) a[i]=1ll*a[i]*(P+-1ll*a[i]*b[i]%P)%P;<br />
    DFT(a,n,inv3);<br />
    int u=ksm(n,P-);<br />
    for (int i=;i&lt;n;i++) a[i]=1ll*a[i]*u%P;<br />
}<br />
int main()<br />
{<br />
#ifndef ONLINE_JUDGE<br />
    freopen("bzoj3456.in","r",stdin);<br />
    freopen("bzoj3456.out","w",stdout);<br />
    const char LL[]="%I64d\n";<br />
#else<br />
    const char LL[]="%lld\n";<br />
#endif<br />
    n=read();inv3=ksm(,P-);<br />
    fac[]=fac[]=;for (int i=;i&lt;=n;i++) fac[i]=1ll*fac[i-]*i%P;<br />
    inv[]=inv[]=;for (int i=;i&lt;=n;i++) inv[i]=P-1ll*(P/i)*inv[P%i]%P;<br />
    for (int i=;i&lt;=n;i++) inv[i]=1ll*inv[i-]*inv[i]%P;<br />
    for (int i=;i&lt;=n;i++) g[i]=1ll*ksm(,(1ll*i*(i-)&gt;&gt;)%(P-))*inv[i]%P,h[i]=1ll*g[i]*i%P;<br />
    int t=;while (t&lt;=(n&lt;&lt;)) t&lt;&lt;=;<br />
    f[]=;<br />
    for (int i=;i&lt;=t;i&lt;&lt;=)<br />
    {<br />
        for (int j=;j&lt;i;j++) tmp[j]=g[j];<br />
        mul(f,tmp,i&lt;&lt;,);<br />
        for (int j=i;j&lt;(i&lt;&lt;);j++) f[j]=;<br />
    }<br />
    for (int i=n+;i&lt;t;i++) f[i]=;<br />
    mul(f,h,t,);<br />
    cout&lt;&lt;1ll*f[n]*fac[n-]%P;<br />
    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49grjlq7.html">（转） &lbrack;it-ebooks&rsqb;电子书列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnvkk38.html">ASP&period;NET sync over async（异步中同步，什么鬼？）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2kzrxq.html">unity导出工程导入到iOS原生工程中详细步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j24708.html">Microsoft Visual Studio 2012注册密钥</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rkld7q.html">【Qt】2&period;3 使用Qt设计师来创建对话框</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1og528.html">【JavaService】部署Java jar为Windows后台服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/3903z249.html">如何自适应网页的协议（http&sol;https&sol;&hellip;&hellip;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdedonx9.html">【LeetCode】58 - Length of Last Word</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdnx138.html">php parallel</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydnm7xq.html">win32画线考虑去锯齿</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m4oy1q.html">依赖注入及AOP简述（六）&mdash;&mdash;字符串请求模式 &period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyw3ge9.html">zTree-已勾选项id传输到action的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1j41xq.html">MTK Android添加驱动模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k34769.html">Mistwald  zoj 3497</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp3w669.html">软件测试实验四----mujava变异测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g34w0q.html">C&num;总结（五）调用C&plus;&plus;动态库&lpar;类型对照&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll5ym1q.html">060 SparkStream 的wordcount示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q252eywq.html">Pilosa文档翻译（三）示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwgzmk8.html">git 管理和存储二进制大文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/960120v9.html">三种初步简易的方法求解数值问题 of C&plus;&plus;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8m2zedpq.html">ubuntu 系统查看opencv 的版本</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2n1ox9.html">Redis 安装部署</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjke6e9.html">WebSphere下配置HTTP压缩</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r2ro28.html">&lbrack;07&rsqb; 使用注解完成IOC配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/960gmd39.html">Flask核心机制--上下文源码剖析</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rlpv49.html">cgroup&period;conf系统初始配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2zw36q.html">Nginx支持WebSocket反向代理-学习小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5m7e7q.html">bash处理一条命令的步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r24g28.html">网易2018&period;03&period;27算法岗，三道编程题100&percnt;样例AC题解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj4ke79.html">M2阶段事后总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
